Unit pcx256;
Interface
Uses Dos,crt;
const
  SprPhMax = 16;                                         {᫮ 䠧  ࠩ}
type
  PSprDta = ^TSprDta;
  TSprDta = record
    NofPhase: Byte;
    SprPtr: array [1..SprPhMax] of Pointer;
    Sz: array [1..SprPhMax] of Word;
  end;                                   {  ⨯  ࠭ ࠩ  }
  PSprXY = ^TSprXY;
  TSprXY = record
    X, Y: Integer;
  end;                                 {⨯  饭   ࠩ}
{****************************************************************************}
Function  SetGraph: Boolean;                             {⠭ ०}
Procedure ClsGraph;                                      {室  ⥪⮢}
Procedure ClearSCr(Color:byte);                   {頥 ࠭ 梥⮬ color}
Procedure SetRGBColor (Color: Word; R, G, B: Byte);   {⠭  梥}
Procedure SetPalette (var Pal);                            {⠭ }
Procedure Line (X1, Y1, X2, Y2: Integer; Color: Byte);        {஢ }
Procedure Bar (X1, Y1, X2, Y2: Integer; Color: Byte); {אַ㣮쭨 .color}
Procedure Rectangle(x,y,x1,y1:integer;c:byte); { אַ㣮쭨 .color}
Procedure Circle(x,y,r:integer;c:byte);                    { 㦭}
Procedure PutPixel (X1, Y1: Integer; Color: Byte);            {뢮 ᥫ}
Function  GetPixel (X1, Y1: Integer): Byte;                {頥 ᥫ}
Procedure InitBlocks;                   {樠 ࠡ  }
Procedure GetBlock (var NBlock:Byte; SzX, SzY: Word);{१ࢨ  ।}
                       { ࠧ.NBlock 䨪, Sz... - ࠧ}
Procedure FreeBlock (var NBlock: Byte);              {᢮  NBlock}
Procedure PutBlock (NBlock: Byte);      {뢮  NBlock  ⨢ }
                                          {室  ࠭  ஫}
Procedure PutBlockXY (NBlock: Byte; X, Y: Integer);  {뢮   NBlock }
 {⨢     न⠬ X,Y.室  ࠭  ஫}
Procedure CutBlock (NBlock: Byte);          {墠뢠  NBlock ࠦ}
                                                           { ⨢ }
Procedure CutBlockXY (NBlock: Byte; X, Y: Integer);{墠뢠   NBlock}
                 {ࠦ  ⨢   窨  न⠬ X, Y.}
Procedure FillBlock (NBlock, Color: Byte);         {頥  梥⮬ color}
Procedure SetActBlock (NBlock: Byte);            { ⨢  NBlock}
Procedure TGetMem (var P:Pointer; Size: Word);{१ࢨ   ஢મ}
Procedure ErrMsg (Msg: String);                  {뢮 ᮮ饭  訡}
Procedure ScrOFF;                                            {몫砥 ࠭}
Procedure ScrSlowOFF;                               { 몫砥 ࠭}
Procedure ScrON;                                              {砥 ࠭}
Procedure ScrSlowON;                                 { 砥 ࠭}
Procedure Wait;                                         { ⨪  ⠩}
Procedure Sync;                                     { ⭮ 室 }
Procedure DisplayPCX (FileName: String);                  {㦠 PCX 䠩}
Procedure SetPCXPal (FileName: String);          {⠭   䠩}
Procedure NormPalette;                                    {頥 }
Procedure LoadSprite (var S: TSprDta; FlNm: PathStr);       {㦠 ࠩ}
Procedure FreeSprite (var S: TSprDta);                    {᢮ }
Procedure PutSprite (PSpr: Pointer; X, Y: Integer);
                                 {뢮 ࠩ   X, Y ⨢ }
Procedure PutVPSprite (PSpr: Pointer; X1, Y1: Integer);
                     {뢮  ࠩ      X1,  Y1   ࠡ⪮ ࠭}
{---------------------------------------------------------------------------}
type                                        {   PCX 䠩 }
  TPCXHeader = record
    Manuf          : Byte;                    { ᥣ = 10                 }
    Hard           : Byte;                    {  ।            }
    Cod            : Byte;                    { Run-length encoding (=1)    }
    BitPrePix      : Byte;                    {   ᥫ               }
    X1             : Word;                    {                             }
    Y1             : Word;                    {                             }
    X2             : Word;                    {                             }
    Y2             : Word;                    {                             }
    HorizRes       : Word;                    { ਧ. ࠧ襭        }
    VertRes        : Word;                    { ⨪쭮 ࠧ襭     }
    Pal            : array[1..48] of Byte;    {                      }
    VMode          : Byte;                    { १                      }
    NUmbOFPlan     : Byte;                    { ᪠            (ver 2.5=0)}
    BytePerLine    : Word;                    {                  }
    Col            : Word;                    {        (1=, 2=.)}
    ScanHor        : Word;                    { ࠧ襭                  }
    ScanVer        : Word;                    {                             }
    Extra          : array[1..54] of Byte;    { 䨫                      }
  end;{*********************************************************************}
Const xasp=0.9;yasp=1;
{===================== ६  ࠭   ======================}
  ActBlPtr: Pointer = Ptr ($A000, 0);
  ActBX: Word = 320;
  ActBY: Word = 200;                        {  ࠧ ⨢ }
  VisBlPtr: Pointer = Ptr ($A000, 0);
  VisBX: Word = 320;
  VisBY: Word = 200;                         {  ࠧ  }
  VBlockNum = 20;                                              {᫮ }
  ActBlock: Byte = 1;
  VisBlock: Byte = 1;                               {⨢   }
  ActXMin: Word = 0;
  ActXMax: Word = 320;
  ActYMin: Word = 0;
  ActYMax: Word = 200*320;                          {࠭ ⨢ }
  VisXMin: Word = 0;
  VisXMax: Word = 320;
  VisYMin: Word = 0;
  VisYMax: Word = 200*320;                           {࠭  }
  ScrDelay: LongInt = 0;                   { ६   ६ }
  OScrTime: LongInt = 0;
type
  TRGB = record R, G, B: Byte end;
  TVBlock = record
    Free: Boolean;
    PutX, PutY: Integer;
    SizeX, SizeY: Word;
    BlPtr: Pointer;
  end;                                                   {⨯  }
  TPtr = record Offs, Segm: Word end;                     {⨯  㪠⥫}
  THead = record X, Y: Word end;
  PHead = ^THead;                                    {⨯  砫 ࠩ}
  PWord = ^Word;
  PByte = ^Byte;
  PPointer = ^Pointer;
  TPalette = array [0..255] of TRGB;                        {⨯  }
var
  Palette: TPalette;                                                {}
  VMCount: Byte;
  VBlock: array [1..VBlockNum] of TVBlock;                       {}
Implementation
{***************************************************************************}
Function SetGraph: Boolean;                               {⠭ 13H}
label NotVGA;
begin
  SetGraph := FALSE;
  asm
    mov   ax, 1A00h
    int   10h
    cmp   al, 1Ah
    jne   NotVGA
    mov bl, 10h
    mov ah, 12h
    int 10h
    mov VMCount, bl
    mov ax, 0013h
    int 10h
  end;
  SetGraph := TRUE;
  ScrOFF;
NotVGA:
end;{------------------------------------------------------------------------}
Procedure ClsGraph; assembler;                           {  ⥪⮢}
asm
  mov ax, 0003h
  int 10h
  mov ax, 1202h
  mov bl, 30h
  int 10h
end;{------------------------------------------------------------------------}
Procedure SetRGBColor (Color: Word; R, G, B: Byte); assembler;
asm
  mov  ax, 1010h
  mov  bx, Color
  mov  dh, R
  mov  ch, G
  mov  cl, B
  int  10h
end;{------------------------------------------------------------------------}
Procedure SetPalette (var Pal); assembler;
asm
  mov   dx, 3C8h
  mov   al, 0
  out   dx, al
  push  ds
  lds   si, Pal
  mov   bx, 2
@@Nxt:
  cli
  mov   dx, 3DAh
@@Wait2:
  in    al, dx
  test  al, 08h
  jz    @@Wait2
  mov   cx, 128*3
  mov   dx, 3C9h
@@PalLoop:
  lodsb
  out   dx, al
  loop  @@PalLoop
  dec   bx
  cmp   bx, 0
  jne   @@Nxt
  sti
  pop   ds
end;{------------------------------------------------------------------------}
Procedure Line (X1, Y1, X2, Y2: Integer; Color: Byte); assembler;
var
  DiagYInc, DiagXInc, Diag_count,
  StrXInc, StrYInc, StrCount,
  ShortDist: Word;
asm
  mov  cx, 1
  mov  dx, 1
  mov  di, Y2
  sub  di, Y1
  jge  @@Keep_Y
  neg  dx
  neg  di
@@Keep_Y:
  mov  DiagYInc, dx
  mov  si, X2
  sub  si, X1
  jge  @@Keep_X
  neg  cx
  neg  si
@@Keep_X:
  mov  DiagXInc,cx
  cmp  si, di
  jge  @@Horz_seg
  mov  cx, 0
  xchg si, di
  jmp  @@Save_values
@@Horz_seg:
  mov  dx, 0
@@Save_values:
  mov  ShortDist, di
  mov  StrXInc,   cx
  mov  StrYInc,   dx                               {᫥  ࠢ}
  mov  ax, ShortDist
  shl  ax, 1
  mov  StrCount, ax                           {  SD*2 -> ⮫쪮 ࠧ ﬠ }
  sub  ax, si
  mov  bx, ax                                             {  BX - (SD*2-LD) }
  sub  ax, si
  mov  Diag_count, ax                 {  (SD-LD)*2 -> ⮫쪮 ࠧ  }
  mov  cx, X1
  mov  dx, Y1
  inc  si          	                          {  SI -  ⠭ }
  mov  es, word ptr ActBlPtr[2]                             { ᭮ 横 }
@@MainLoop:
  dec  si
  jl   @@Done                                   { 뢮 窠 X-CX Y-DX }
  cmp  cx, ActBX
  jae  @@Hole
  cmp  dx, ActBY
  jae  @@Hole
  push dx
  mov  di, word ptr ActBlPtr
  mov  ax, ActBX
  mul  dx
  add  di, ax
  add  di, cx
  mov  al, Color
  mov  byte ptr es:[di], al
  pop  dx
@@Hole:
  cmp  bx, 0
  jge  @@Diag_line
  add  cx, StrXInc
  add  dx, StrYInc
  add  bx, StrCount
  jmp  @@MainLoop
@@Diag_line:
  add  cx, DiagXInc
  add  dx, DiagYInc
  add  bx, Diag_count
  jmp  @@MainLoop
@@Done:
end;{------------------------------------------------------------------------}
Procedure Bar (X1, Y1, X2, Y2: Integer; Color: Byte);
var
  XCount, YCount, XInc: Integer;
begin
  XCount := X2 - X1;
  YCount := Y2 - Y1;
  XInc := ActBX - XCount;
  asm
    les  di, ActBlPtr
    mov  ax, Y1
    mov  bx, ActBX
    mul  bx
    add  ax, X1
    add  di, ax
    mov  dx, YCount
@@NxtStr:
    mov  al, Color
    mov  cx, XCount
    rep  stosb
    dec  dx
    add  di, XInc
    cmp  dx, 0
    jg   @@NxtStr
  end;
end;{------------------------------------------------------------------------}
Procedure ClearSCr(Color:byte);assembler;        {頥 ࠭ 梥⮬ color}
asm
   MOV AX,0A000H
   MOV ES,AX
   mov di,0
   MOV CX,32000
   MOV AL,color
   MOV AH,color
   REP STOSW
end;{-----------------------------------------------------------------------}
Procedure Rectangle(x,y,x1,y1:integer;c:byte);{ אַ㣮쭨 .color}
begin
line(x,y,x1,y,c);
line(x,y1,x1+1,y1,c);
line(x,y,x,y1,c);
line(x1,y,x1,y1,c);
end;{-----------------------------------------------------------------------}
Procedure Circle(x,y,r:integer;c:byte);               { 㦭   }
Var I,x1,y1,x2,y2 : integer;                          {業஬ x,y 梥⮬ c }
Begin
 For I := 0 To 360 Do
 Begin
 x1 := x + Round(r*Sin(2*pi*i/360));
 y1 := y - Round(r*xasp*Cos(2*pi*i/360/yasp)); i:=i+1;
 x2 := x + Round(r*Sin(2*pi*i/360));
 y2 := y - Round(r*xasp*Cos(2*pi*i/360)/yasp); i:=i-1;
 line (x1,y1,x2,y2,c);
 End;
end;{-----------------------------------------------------------------------}
Procedure PutPixel (X1, Y1: Integer; Color: Byte); assembler;
asm
  les  di, ActBlPtr
  mov  ax, Y1
  mov  bx, ActBX
  mul  bx
  add  ax, X1
  add  di, ax
  mov  al, Color
  stosb
end;{------------------------------------------------------------------------}
Function GetPixel (X1, Y1: Integer): Byte; assembler;
asm
  les  di, ActBlPtr
  mov  ax, Y1
  mov  bx, ActBX
  mul  bx
  add  ax, X1
  add  di, ax
  mov  al, byte ptr es:[di]
end;{------------------------------------------------------------------------}
Procedure InitBlocks;
var
  i: Byte;
begin
  for i:=1 to VBlockNum do
    with VBlock[i] do  Free := TRUE;
  with VBlock [VisBlock] do begin
    Free := FALSE;
    SizeX := 320;
    SizeY := 200;
    BlPtr := VisBlPtr;
  end;
  SetActBlock (VisBlock);
end;{------------------------------------------------------------------------}
Procedure GetBlock (var NBlock: Byte; SzX, SzY: Word);
var
  i: Byte;
  Size: Word;
begin
  i:=0;
  repeat
    Inc (i);
  until VBlock[i].Free or (i > VBlockNum);
  if i > VBlockNum then ErrMsg ('Not enough VBlocks');
  NBlock := i;
  with VBlock[i] do begin
    Free := FALSE;
    SizeX := SzX;
    SizeY := SzY;
    TGetMem (BlPtr, SizeX*SizeY);
  end;
end;{------------------------------------------------------------------------}
Procedure FreeBlock (var NBlock: Byte);
begin
  with VBlock[NBlock] do begin
    FreeMem (BlPtr, SizeX*SizeY);
    Free := TRUE;
  end;
end;{------------------------------------------------------------------------}
Procedure FillBlock (NBlock, Color: Byte);
var
  Count: Word;
  DstPtr: Pointer;
begin
  with VBlock [NBlock] do begin
    Count := SizeX*SizeY;
    DstPtr := BlPtr;
  end;
  asm
    les  di, DstPtr
    mov  al, Color
    mov  ah, al
    mov  cx, Count
    shr  cx, 1
    rep  stosw
  end;
end;{------------------------------------------------------------------------}
Procedure PutBlock (NBlock: Byte);
var
  Count: Word;
  SrcPtr, DstPtr: Pointer;
  SzX, SzY, XInc: Word;
begin
  with VBlock [NBlock] do begin
    SzX := SizeX;
    SzY := SizeY;
    SrcPtr := BlPtr;
    XInc := ActBX - SizeX;
    DstPtr := Pointer (LongInt (ActBlPtr) + PutY * ActBX + PutX);
  end;
  if (SzX=0) or (SzY=0) then Exit;
  asm
    push ds
    les  di, DstPtr
    lds  si, SrcPtr
    mov  dx, SzY
@@NxtStr:
    mov  cx, SzX
    rep  movsb
    add  di, XInc
    dec  dx
    cmp  dx, 0
    jg   @@NxtStr
    pop  ds
  end;
end;{------------------------------------------------------------------------}
Procedure PutBlockXY (NBlock: Byte; X, Y: Integer);
var
  Count: Word;
  SrcPtr, DstPtr: Pointer;
  SzX, SzY, XInc: Word;
begin
  with VBlock [NBlock] do begin
    SzX := SizeX;
    SzY := SizeY;
    SrcPtr := BlPtr;
    XInc := ActBX - SzX;
    DstPtr := Pointer (LongInt (ActBlPtr) + Y * ActBX + X);
  end;
  if (SzX=0) or (SzY=0) then Exit;
  asm
    push ds
    les  di, DstPtr
    lds  si, SrcPtr
    mov  dx, SzY
@@NxtStr:
    mov  cx, SzX
    rep  movsb
    add  di, XInc
    dec  dx
    cmp  dx, 0
    jg   @@NxtStr
    pop  ds
  end;
end;{------------------------------------------------------------------------}
Procedure CutBlock (NBlock: Byte);
var
  SrcPtr, DstPtr: Pointer;
  SzX, SzY, PX, PY, XInc: Integer;
begin
  with VBlock [NBlock] do begin
    SzX := SizeX; SzY := SizeY;
    DstPtr := BlPtr;
    XInc := ActBX - SzX;
    SrcPtr := Pointer (LongInt (ActBlPtr) + PutY * ActBX + PutX);
  end;
  if (SzX=0) or (SzY=0) then Exit;
  asm
    push ds
    les  di, DstPtr
    lds  si, SrcPtr
    mov  dx, SzY
@@NxtStr:
    mov  cx, SzX
    rep  movsb
    add  si, XInc
    dec  dx
    cmp  dx, 0
    jg   @@NxtStr
    pop  ds
  end;
end;{------------------------------------------------------------------------}
Procedure CutBlockXY (NBlock: Byte; X, Y: Integer);
var
  SrcPtr, DstPtr: Pointer;
  SzX, SzY, XInc: Word;
begin
  with VBlock [NBlock] do begin
    SzX := SizeX;
    SzY := SizeY;
    DstPtr := BlPtr;
    XInc := ActBX - SzX;
    SrcPtr := Pointer (LongInt (ActBlPtr) + Y * ActBX + X);
  end;
  if (SzX=0) or (SzY=0) then Exit;
  asm
    push ds
    les  di, DstPtr
    lds  si, SrcPtr
    mov  dx, SzY
@@NxtStr:
    mov  cx, SzX
    rep  movsb
    add  si, XInc
    dec  dx
    cmp  dx, 0
    jg   @@NxtStr
    pop  ds
  end;
end;{------------------------------------------------------------------------}
Procedure SetActBlock (NBlock: Byte);
begin
  ActBlock := NBlock;
  with VBlock [ActBlock] do begin
    ActBlPtr := BlPtr;
    ActBX := SizeX;
    ActBY := SizeY;
    ActXMin := 0;
    ActXMax := ActBX;
    ActYMin := TPtr (BlPtr).Offs;
    ActYMax := TPtr (BlPtr).Offs + SizeY * ActBX;
  end;
end;{------------------------------------------------------------------------}
Procedure TGetMem (var P: Pointer; Size: Word);
var
  St: String [11];
  TstSize, TstAvail: LongInt;
begin
  TstSize := Size;
  TstAvail := MaxAvail;
  if TstAvail < TstSize then begin
    Str (TstSize - TstAvail, St);
    ErrMsg ('Not enough memory :' + St + ' Byte');
  end;
  GetMem (P, Size);
end;{------------------------------------------------------------------------}
Procedure ErrMsg (Msg: String);
begin
  ClsGraph;
  WriteLn (Msg);
  Halt (1);
end;{------------------------------------------------------------------------}
Procedure ScrOFF;
var
  TmpPal: array [0..255] of TRGB;
  i: Byte;
begin
  for i:=0 to 255 do
    with TmpPal[i] do begin
      R := 0; G := 0; B:=0;
    end;
  SetPalette (TmpPal);
end;{------------------------------------------------------------------------}
Procedure ScrSlowOFF;
var
  TmpPal: array [0..255] of TRGB;
  i, j: Byte;
  NScrTime: LongInt absolute $0040:$006C;
begin
  for j:=64 downto 1 do begin
    for i:=0 to 255 do
      with TmpPal[i] do begin
        R := Palette[i].R * j div 64;
        G := Palette[i].G * j div 64;
        B := Palette[i].B * j div 64;
      end;
    repeat until NScrTime - OScrTime > 0;
    OScrTime := NScrTime;
    SetPalette (TmpPal);
  end;
end;{------------------------------------------------------------------------}
Procedure ScrON;
var
  TmpPal: array [0..255] of TRGB;
  i: Byte;
begin
  for i:=0 to 255 do
    with TmpPal[i] do begin
      R := 0; G := 0; B:=0;
    end;
  SetPalette (Palette);
end;{------------------------------------------------------------------------}
Procedure ScrSlowON;
var
  TmpPal: array [0..255] of TRGB;
  i, j: Byte;
  NScrTime: LongInt absolute $0040:$006C;
begin
  for j:=1 to 64 do begin
    for i:=0 to 255 do
      with TmpPal[i] do begin
        R := Palette[i].R * j div 64;
        G := Palette[i].G * j div 64;
        B := Palette[i].B * j div 64;
      end;
    repeat until NScrTime - OScrTime > 0;
    OScrTime := NScrTime;
    SetPalette (TmpPal);
  end;
end;{------------------------------------------------------------------------}
Procedure Wait;
var
  NScrTime: LongInt absolute $0040:$006C;
begin
  if NScrTime > 5 then
    repeat
    until  NScrTime - OScrTime > ScrDelay;
  OScrTime := NScrTime;
end;{------------------------------------------------------------------------}
Procedure Sync; assembler;
asm
  mov  dx, 3DAh
@@Wait:
  in   al, dx
  test al, 08h
  jz @@Wait
end;{------------------------------------------------------------------------}
Procedure DisplayPCX (FileName: String);
var
  PCXFile: File;
  Header: TPCXHeader;
  Body: Pointer;
  NumRead, ByteCnt,
  DispStr, DispByte, CurShift: Word;
  Plan, Numb, RealCount: Byte;
  Value: Byte;
  DataP, CarPtr: ^Byte;
  Change: Boolean;
  BuffSize, i: Word;
Procedure PCXEnd;
begin
  Close (PCXFile);
  FreeMem (Body, BuffSize);
end;
Procedure PCXBegin;
begin
  Assign (PCXFile, FileName);
  Reset (PCXFile, 1);
  BlockRead (PCXFile, Header, SizeOf (TPCXHeader), NumRead);
  BuffSize := 10000;
  GetMem (Body, BuffSize);
  CarPtr := ActBlPtr;
  DispByte := 0;
  Plan := 0;
  DispStr := 0;
end;
Procedure UnPack;
begin
  if (DataP^ >= $C0) then begin
    Numb := DataP^ - $C0;
    Inc (LongInt (DataP)); Inc (ByteCnt);
    if (ByteCnt >= NumRead) then begin
      Seek (PCXFile, FilePos (PCXFile) - 1);
      Numb := 0;
    end;
    Value := DataP^;
    Inc (LongInt (DataP)); Inc (ByteCnt);
  end
  else begin
    Numb := 1;
    Value := DataP^;
    Inc (LongInt (DataP)); Inc (ByteCnt);
  end;
end;
Procedure ChangePlan;
begin
  DispByte := 0;
  Inc (Plan);
  if (Plan = Header.NumbOfPlan) then begin
    Plan := 0;
    Inc (DispStr);
    Inc (LongInt (CarPtr), Header.HorizRes);
  end;
end;
Procedure EOLControl;
begin
  if (DispByte + Numb < Header.BytePerLine) then begin
    RealCount := Numb;
    Numb := 0;
    Change := False;
  end
  else begin
    RealCount := Header.BytePerLine - DispByte;
    Numb := Numb - RealCount;
    Change := True;
  end;
end;
begin
  PCXBegin;
  while (NumRead <> 0) do begin
    BlockRead (PCXFile, Body^, BuffSize, NumRead);
    DataP := Addr (Body^);
    ByteCnt := 0;
    while (ByteCnt < NumRead) do begin
      UnPack;
      while (Numb > 0) do begin
        EOLControl;
          for i:=1 to RealCount do begin
            CurShift := DispByte;
            asm
              les   di, CarPtr
              add   di, CurShift
              mov   al, Value
              mov   byte ptr es:[di], al
            end;
            Inc (DispByte);
          end;
        if Change then begin
          ChangePlan;
          if (DispStr = Header.VertRes) then begin
            PCXEnd;
            Exit;
          end;end;end;end;end;
  PCXEnd;
end;{------------------------------------------------------------------------}
Procedure NormPalette;
var
  Pal: array [1..768] of Byte absolute Palette;
  i: Word;
begin
  for i:=1 to 768 do Pal[i] := Pal[i] shr 2;
end;{------------------------------------------------------------------------}
Procedure SetPCXPal (FileName: String);
var
  PCXFile: File;
  NumRead: Word;
  Ident, i: Byte;
begin
  Assign (PCXFile, FileName);
  Reset (PCXFile, 1);
  Seek (PCXFile, FileSize (PCXFile) - 769);
  BlockRead (PCXFile, Ident, 1, NumRead);
  BlockRead (PCXFile, Palette, 768, NumRead);
  Close (PCXFile);
  NormPalette;
end;{------------------------------------------------------------------------}
Procedure LoadSprite (var S: TSprDta; FlNm: PathStr);
var
  NB, NumRead: Word;
  i: Byte;
  Handle: File;
begin
  Assign (Handle, FlNm);
  Reset (Handle, 1);
  if IOResult <> 0 then ErrMsg ('File not found '+ FlNm);
  i := 0;
  with S do
    repeat
      BlockRead (Handle, NB, 2, NumRead);
      if NumRead <> 2 then begin
        NOfPhase := i;
        Close (Handle);
        Exit;
      end;
      Inc (i);
      Sz[i] := NB;
      TGetMem (SprPtr[i], NB);
      BlockRead (Handle, SprPtr[i]^, NB, NumRead);
      if NumRead <> NB then ErrMsg ('Reading error in '+ FlNm);
    until FALSE;
end;{------------------------------------------------------------------------}
Procedure FreeSprite (var S: TSprDta);
var
  i: Byte;
begin
  with S do
    for i:=1 to NofPhase do
      FreeMem (SprPtr[i], Sz[i]);
end;{------------------------------------------------------------------------}
Procedure PutSprite (PSpr: Pointer; X, Y: Integer);
var
  XCount, YCount, XInc: Integer;
begin
  XCount := PSprXY(PSpr)^.X;
  YCount := PSprXY(PSpr)^.Y;
  XInc := ActBX - XCount;
  asm
    les  di, ActBlPtr
    mov  ax, Y
    mov  bx, ActBX
    mul  bx
    add  ax, X
    add  di, ax
    mov  dx, YCount
    push ds
    lds  si, PSpr
    add  si, 4
    mov  ah, 0
@@NxtStr:
    mov  cx, XCount
@@NxtByte:
    lodsb
    cmp  al, ah
    je   @@Hole
    stosb
    jmp  @@Fill
@@Hole:
    inc  di
@@Fill:
    loop @@NxtByte
    dec  dx
    add  di, XInc
    cmp  dx, 0
    jg   @@NxtStr
    pop  ds
  end;
end;{------------------------------------------------------------------------}
Procedure PutVPSprite (PSpr: Pointer; X1, Y1: Integer);
var
  X2, Y2: Integer;
  XCount, YCount, IncX,
  PreX, PreY, PostX, PostY: Word;
begin
  XCount := PSprXY (PSpr)^.X;
  YCount := PSprXY (PSpr)^.Y;
  PreX := 0; PreY := 0;
  PostX := 0; PostY := 0;
  X2 := X1 + XCount; Y2 := Y1 + YCount;
  if X1 >= ActBX then Exit;
  if Y1 >= ActBY then Exit;
  if X1 <= 0     then begin PreX:= -X1; XCount := XCount - PreX; X1 := 0 end;
  if Y1 <= 0     then begin PreY:= -Y1; YCount := YCount - PreY; Y1 := 0 end;
  if X2 <= 0     then Exit;
  if Y2 <= 0     then Exit;
  if X2 >= ActBX then begin PostX:= X2 - ActBX; XCount := XCount - PostX; end;
  if Y2 >= ActBY then begin PostY:= Y2 - ActBY; YCount := YCount - PostY; end;
  PreY := PreY * PSprXY (PSpr)^.X;
  IncX := ActBX - XCount;
  asm
    les  di, ActBlPtr
    mov  ax, Y1
    mov  bx, ActBX
    mul  bx
    add  di, ax
    add  di, X1
    mov  dx, YCount
    push ds
    lds  si, PSpr
    add  si, 4
    add  si, PreY
@@NxtStr:
    mov  cx, XCount
    add  si, PreX
@@NxtByte:
    mov  al, byte ptr ds:[si]
    cmp  al, 0
    je   @@Hole
    mov  byte ptr es:[di], al
@@Hole:
    inc  si
    inc  di
    loop @@NxtByte
    add  si, PostX
    dec  dx
    add  di, IncX
    cmp  dx, 0
    jg   @@NxtStr
@@Done:
    pop  ds
  end;
end;{------------------------------------------------------------------------}




end.